<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "customer".
 *
 * @property int $id
 * @property string $name
 * @property string $sex
 * @property string $beizhu
 * @property string $tel
 * @property string $xiaofei
 * @property string $species
 */
class Customer extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'customer';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['name', 'sex', 'beizhu', 'tel', 'xiaofei', 'species'], 'string', 'max' => 100],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'sex' => 'Sex',
            'beizhu' => 'Beizhu',
            'tel' => 'Tel',
            'xiaofei' => 'Xiaofei',
            'species' => 'Species',
        ];
    }
}
